Attribute VB_Name = "modInfoSpoolFile"
Option Explicit

Public colInfoSpoolFiles As New Collection

' SpoolFileName = Postscript data file
Public Function CreateInfoSpoolFile(spoolFileName As String, Optional InfoSpoolFileName, Optional ClientComputer, Optional DocumentTitle, _
 Optional JobID, Optional PrinterName, Optional SessionID, Optional UserName, Optional WinStation, Optional relative As Boolean = True)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010
50020  Dim ini As clsINI, Path As String, File As String, psFileName As String
50030
50040  Set ini = New clsINI
50050  ini.Section = "1"
50060
50070  If relative Then
50080    SplitPath spoolFileName, , Path, psFileName, File
50090   Else
50100    psFileName = spoolFileName
50110  End If
50120  If Not IsMissing(InfoSpoolFileName) Then
50130    ini.filename = CStr(InfoSpoolFileName)
50140   Else
50150    ini.filename = CompletePath(Path) & File & ".inf"
50160  End If
50170
50180  If Not IsMissing(ClientComputer) Then
50190    ini.SaveKey CStr(ClientComputer), "ClientComputer"
50200   Else
50210    ini.SaveKey GetComputerName, "ClientComputer"
50220  End If
50230  If Not IsMissing(DocumentTitle) Then
50240    ini.SaveKey CStr(DocumentTitle), "DocumentTitle"
50250   Else
50260    ini.SaveKey GetPSTitle(spoolFileName), "DocumentTitle"
50270  End If
50280  If Not IsMissing(JobID) Then
50290    ini.SaveKey CStr(JobID), "JobID"
50300   Else
50310    ini.SaveKey "0", "JobID"
50320  End If
50330  If Not IsMissing(PrinterName) Then
50340    ini.SaveKey CStr(PrinterName), "PrinterName"
50350   Else
50360    ini.SaveKey "", "PrinterName"
50370  End If
50380  If Not IsMissing(SessionID) Then
50390    ini.SaveKey CStr(SessionID), "SessionID"
50400   Else
50410    ini.SaveKey "", "SessionID"
50420  End If
50430  ini.SaveKey psFileName, "SpoolFileName"
50440  If Not IsMissing(UserName) Then
50450    ini.SaveKey CStr(UserName), "UserName"
50460   Else
50470    ini.SaveKey GetUsername, "UserName"
50480  End If
50490  If Not IsMissing(WinStation) Then
50500    ini.SaveKey CStr(WinStation), "WinStation"
50510   Else
50520    ini.SaveKey Environ$("SESSIONNAME"), "WinStation"
50530  End If
50540  CreateInfoSpoolFile = ini.filename
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modInfoSpoolFile", "CreateInfoSpoolFile")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Sub KillInfoSpoolFiles(InfoSpoolFileName As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim isf As clsInfoSpoolFile, isfi As clsInfoSpoolFileInfo, i As Long, Path As String, File As String, PDFInfoFileName As String, StampFileName As String, PDFDocViewFileName As String, PDFDefAXFileName As String
50020  Dim Path2 As String
50030
50040  SplitPath InfoSpoolFileName, , Path, , File
50050
50060  Set isf = New clsInfoSpoolFile
50070  isf.ReadInfoFile InfoSpoolFileName
50080  For i = 1 To isf.InfoFiles.Count
50090   Set isfi = isf.InfoFiles(i)
50100   SplitPath isfi.spoolFileName, , Path2
50110   If LenB(Path2) = 0 Then
50120    KillFile CompletePath(Path) & isfi.spoolFileName
50130   End If
50140  Next i
50150
50160  KillFile InfoSpoolFileName
50170
50180  PDFInfoFileName = CompletePath(Path) & File & ".mtd"
50190  KillFile PDFInfoFileName
50200  StampFileName = CompletePath(Path) & File & ".stm"
50210  KillFile StampFileName
50220  PDFDocViewFileName = CompletePath(Path) & File & ".dvw"
50230  KillFile PDFDocViewFileName
50240  PDFDefAXFileName = CompletePath(Path) & File & ".def"
50250  KillFile PDFDefAXFileName
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modInfoSpoolFile", "KillInfoSpoolFiles")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

Public Function GetInfoSpoolFileObject(filename As String) As clsInfoSpoolFile
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  Dim isf As clsInfoSpoolFile
50020  If CollectionItemExists(filename, colInfoSpoolFiles) = False Then
50030    Set isf = New clsInfoSpoolFile
50040    isf.ReadInfoFile filename
50050    colInfoSpoolFiles.Add isf, filename
50060    Set GetInfoSpoolFileObject = isf
50070   Else
50080    Set GetInfoSpoolFileObject = colInfoSpoolFiles(filename)
50090  End If
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Function
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modInfoSpoolFile", "GetInfoSpoolFileObject")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Function
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Function

Public Sub RemoveInfoSpoolFileObject(filename As String)
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
On Error GoTo ErrPtnr_OnError
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
50010  colInfoSpoolFiles.Remove filename
'---ErrPtnr-OnError-START--- DO NOT MODIFY ! ---
Exit Sub
ErrPtnr_OnError:
Select Case ErrPtnr.OnError("modInfoSpoolFile", "RemoveInfoSpoolFileObject")
Case 0: Resume
Case 1: Resume Next
Case 2: Exit Sub
Case 3: End
End Select
'---ErrPtnr-OnError-END--- DO NOT MODIFY ! ---
End Sub

